smiley
	var
		tmp/before
		tmp/after
		tmp/smileystate

		basefile = 'base.dmi'
		smilefile = 'smiley.dmi'

		list/leadchars

		list/legalsegments=list(\
			list( /* smiley type :) */ \
				list(":",";",">:","<:","/:",":,","<:,",">;","<;","%"),
				list("-","o"),
				list(")","(","D","o","|","/","S","P","p","d","v")),
			list( /* smiley type ^_^ */\
				list("^","o","O","-","<",">"),
				list("_","."),
				list("^","o","O","-","<",">")))
		list/subsegments=list(\
			list( /* smiley type :) */\
				list("="=":","\\"="/","'"=",","}"=">"),
				list("^"="-","O"="o","0"="o"),
				list("]"=")","\["="(",">"=")","<"="(","\\"="/","O"="o","0"="o","*"="o","s"="S","b"="p",""="p","q"="d","V"="v")),
			list( /* smiley type ^_^ */\
				list("0"="O"),
				list("*"="."),
				list("0"="O")))
		list/segmentnames=list(list("eyes",null,"mouth"),list("weyes","wmouth","weyes"))

		list/rules=list(\
			"eyes::,"="mouth:( mouth:o mouth:S",
			"eyes:<:,"="mouth:( mouth:o mouth:S",
			"eyes:;"="mouth:) mouth:D mouth:p",
			"eyes:>;"="mouth:) mouth:( mouth:D mouth:P mouth:p mouth:d",
			"eyes:<;"="mouth:) mouth:( mouth:D mouth:P mouth:p",
			"eyes:/:"="mouth:| mouth:/ mouth:S",
			"mouth:v"="eyes:: eyes:>: eyes:%",
			"mouth:D"="eyes:: eyes:>: eyes:<: eyes:; eyes:>; eyes:<; eyes:%",
			"mouth:p"="eyes:: eyes:>: eyes:<: eyes:; eyes:>; eyes:<; eyes:%",
			"mouth:d"="eyes:: eyes:>: eyes:<: eyes:; eyes:>; eyes:%",
			"wmouth:."="weyes:^^",
			"weyes:^^"="wmouth:) wmouth:.",
			"weyes:<<"="wmouth:_",
			"weyes:>>"="wmouth:_",
			"wmouth:)"="weyes:^^")
		list/defaults=list(\
			"eyes::,"="mouth:(",
			"eyes:<:,"="mouth:(",
			"eyes:;"="mouth:)",
			"eyes:>;"="mouth:)",
			"eyes:<;"="mouth:(",
			"eyes:/:"="mouth:|",
			"mouth:v"="eyes:>:",
			"mouth:D"="eyes::",
			"mouth:p"="eyes::",
			"mouth:d"="eyes::",
			"wmouth:."="wmouth:_",
			"weyes:^^"="wmouth:)",
			"weyes:<<"="wmouth:_",
			"weyes:>>"="wmouth:_",
			"wmouth:)"="weyes:^^")

		list/replacements=list("oo_"=":|","OO_"="<:o","-o_"=";)","Oo_"="%|")

		list/basesmileys
		list/legalsmileys

		// this is a working value
		tmp/list/segments

	New()
		if(!basesmileys) basesmileys=icon_states(basefile)
		if(!leadchars)
			leadchars = new
			var/i,j
			for(i in legalsegments)
				for(j in i[1])
					if(j) leadchars[copytext(j,1,2)]=1
			for(i in subsegments)
				for(j in i[1])
					if(j) leadchars[j]=1

	proc/GenerateSmileys(client/C)
		legalsmileys=new
		var/list/stack=new
		var/list/tsegs=new
		var/i=0,j,k=1,s=""
		var/icon/I = new(basefile, pick(icon_states(basefile)))
		var/list/done=new
		for(var/tp=1,tp<=legalsegments.len,++tp)
			i=0; k=1; stack.Cut()
			while(1)
				if(++i>length(legalsegments[tp][k]))
					if(--k<=0) break
					i=stack[stack.len]
					--tsegs.len
					--stack.len
					continue
				if(k==length(legalsegments[tp]))
					if(!segmentnames[tp][k])
						if(--k<=0) break
						i=stack[stack.len]
						--tsegs.len
						--stack.len
						continue
					sleep()
					tsegs+=legalsegments[tp][k][i]
					segments=GetSegmentList(tp,tsegs)
					--tsegs.len
					if(!segments) continue
					s=""
					for(j in segments) s+=segments[j]
					if(done[s]) continue
					done[s]=1
					var/icon/J = new(basefile,segments[segments.len]+":"+segments[segments[segments.len]])
					for(j=segments.len-1,j>0,--j)
						if(!segments[segments[j]]) continue
						J.Blend(new/icon(basefile,segments[j]+":"+segments[segments[j]]),ICON_OVERLAY)
					I.Insert(J,s)
					if(done.len==1) I.Insert(J,"")
					continue
				tsegs+=legalsegments[tp][k][i]
				if(!segmentnames[tp][k])
					i=length(legalsegments[tp][k])
				stack+=i
				sleep()
				i=0; ++k; continue
		C << ftp(fcopy_rsc(I),"output.dmi")

	proc/IsFinished(tp,segment)
		if(segment<1 || segment>length(legalsegments[tp])) return 0
		if(!segments) segments=new
		if(segment>segments.len)
			if(!segments) segments=new
			var/j=segments.len
			for(var/i=segments.len+1,i<=segment,++i)
				segments+=null
				// required segment
				if(segmentnames[tp][i] && !(null in legalsegments[tp][i]))
					segments.len=j
					return 0
		if(!segments[segment] && !segmentnames[tp][segment]) return 1
		if(segments[segment] in legalsegments[tp][segment]) return 1

	proc/SplitHere(tp,segment,ch)
		if(segment>segments.len) return 1
		var/oldseg = segments[segment]
		var/ach = ascii2text(ch)
		if(subsegments[tp][segment][ach]) ach = subsegments[tp][segment][ach]
		var/newseg = oldseg + ach
		for(var/anyseg in legalsegments[tp][segment])
			if(anyseg!=oldseg && findText(anyseg,newseg)==1) return 0
		return 1

	proc/FirstSegment(tp,ch)
		if(!segments) segments=new
		.=segments.len||1
		while(.<=length(legalsegments[tp]))
			if(.>segments.len)
				segments+=null
				if(!IsFinished(tp,segments.len) && SplitHere(tp,segments.len,ch)) return 0
				continue
			if(!SplitHere(tp,.,ch)) return
			else if(!IsFinished(tp,.)) return 0
			++.
		if(.>length(legalsegments[tp])) return 0

	proc/SmileyType(txt,i=1)
		.=1
		var/ch,ach,j,k,m
		var/seg,subtxt
		segments=null
		if(!legalsmileys) legalsmileys=icon_states(smilefile)
		while(.<=legalsegments.len)
			ch=text2ascii(txt,i)
			seg=FirstSegment(.,ch)
			if(!seg)
				++.; continue
			j=i
			while(seg)
				while(seg>segments.len) segments+=null
				ach=ascii2text(ch)
				if(subsegments[.][seg][ach]) ach=subsegments[.][seg][ach]
				if(!segments[seg]) segments[seg]=ach
				else segments[seg]+=ach
				if(++j>length(txt)) break
				ch=text2ascii(txt,j)
				seg=FirstSegment(.,ch)
			k=length(legalsegments[.])
			if((segments.len<k || !segments[k]) && segmentnames[.][k] && !(null in legalsegments[.][k]))
				// move nose to mouth if no mouth specified (or what have you)
				if(segments.len>=k-1 && (!segmentnames[.][k-1] || (null in legalsegments[.][k-1])))
					if(segments.len>=k) segments.Cut(k)
					segments+=segments[k-1]
					segments[k-1]=null
				else
					segments.Cut()
					++.; continue
			subtxt=""
			for(m=1,m<=k,++m)
				subtxt+=segments[m]
			subtxt = RedoSegments(.)
			if(!subtxt)
				segments.Cut()
				++.; continue
			if(subtxt in legalsmileys)
				segments.Cut()
				smileystate = subtxt
				before = i
				after = j
				return
			segments.Cut()
			++.
		segments.Cut()
		if(.>legalsegments.len) return 0

	proc/GetSegmentList(tp,list/segs)
		var/i,j,k,s1,s2
		var/list/seglist=new
		segs=segs.Copy()
		// first find any segments with the same name, and arrange them
		for(i=1,i<segs.len,++i)
			if(segs[i] && segmentnames[tp][i])
				for(j=i+1,j<=segs.len,++j)
					if(segs[j] && segmentnames[tp][j]==segmentnames[tp][i])
						if(segs[i]>segs[j])
							segs.Swap(i,j)
		// now combine them
		for(i=1,i<=segs.len,++i)
			s1=segmentnames[tp][i]
			if(segs[i] && s1)
				if(seglist[s1]) seglist[s1]+=segs[i]
				else seglist[s1]=segs[i]
		// look for rules forcing substitutions
		for(i in seglist)
			s1=i+":"+seglist[i]
			if(rules[s1])
				for(j in seglist)
					if(j==i) continue
					s2=j+":"+seglist[j]
					k=findText(rules[s1],s2)
					while(k)
						if(k>1 && text2ascii(rules[s1],k-1)>32)
							k=findText(rules[s1],s2,k+1)
							continue
						if(k+length(s2)<=length(rules[s1]) && text2ascii(rules[s1],k+length(s2))>32)
							k=findText(rules[s1],s2,k+1)
							continue
						break
					if(!k)
						// rule violation found; substitute a default or bail
						s2=defaults[s1]
						if(!s2) return
						k=findText(s2,":")
						seglist[copytext(s2,1,k)]=copytext(s2,k+1)
		s1=""
		for(i in seglist)
			s1+=seglist[i]
		// don't count smileys with replacements
		if(s1 in replacements) return
		// if this smiley can't actually be built, then it doesn't count!
		for(i in seglist)
			s2=i+":"+seglist[i]
			if(!(s2 in basesmileys)) return
		return seglist

	proc/RedoSegments(tp,parsing)
		var/i,j,k,s1,s2
		var/list/seglist=new
		// first find any segments with the same name, and arrange them
		for(i=1,i<segments.len,++i)
			if(segments[i] && segmentnames[tp][i])
				for(j=i+1,j<=segments.len,++j)
					if(segments[j] && segmentnames[tp][j]==segmentnames[tp][i])
						if(segments[i]>segments[j])
							segments.Swap(i,j)
		// now combine them
		for(i=1,i<=segments.len,++i)
			s1=segmentnames[tp][i]
			if(segments[i] && s1)
				if(seglist[s1]) seglist[s1]+=segments[i]
				else seglist[s1]=segments[i]
		// look for rules forcing substitutions
		for(i in seglist)
			s1=i+":"+seglist[i]
			if(rules[s1])
				for(j in seglist)
					if(j==i) continue
					s2=j+":"+seglist[j]
					k=findText(rules[s1],s2)
					while(k)
						if(k>1 && text2ascii(rules[s1],k-1)>32)
							k=findText(rules[s1],s2,k+1)
							continue
						if(k+length(s2)<=length(rules[s1]) && text2ascii(rules[s1],k+length(s2))>32)
							k=findText(rules[s1],s2,k+1)
							continue
						break
					if(!k)
						// rule violation found; substitute a default or bail
						s2=defaults[s1]
						if(!s2) return 0
						k=findText(s2,":")
						seglist[copytext(s2,1,k)]=copytext(s2,k+1)
		s1=""
		for(i in seglist) s1+=seglist[i]
		if(s1 in replacements)
			// if the parsing flag is set, we need to remake this smiley
			// otherwise, we just need to confirm it's valid
			if(parsing) Parse(replacements[s1])
			return replacements[s1]
		// if this smiley can't actually be built, then it doesn't count!
		for(i in seglist)
			s2=i+":"+seglist[i]
			if(!(s2 in basesmileys)) return 0
		return s1

	proc/Parse(txt,start=1,replace)
		var/ch,i=start,tp
		var/subtxt
		segments=null
		if(!legalsmileys) legalsmileys=icon_states(smilefile)
		before=0; after=0; smileystate=null
		while(i<=length(txt))
			ch=text2ascii(txt,i)
			if(ch>32)
				if(leadchars[ascii2text(ch)])
					tp=SmileyType(txt,i)
					if(tp)
						segments=null
						if(!replace) return smileystate
						subtxt=ReplacementImg()
						txt=copytext(txt,1,before)+subtxt+copytext(txt,after)
						after=before+length(subtxt)
						segments=null
						continue
					segments=null
			++i
		if(!replace) return 0
		return txt

	proc/ReplacementImg(s=smileystate,f=smilefile)
		return "<IMG SRC=\ref[f] CLASS=icon ICONSTATE='[s]'>"

	proc/ParseHTML(txt)
		.=""
		var/i=1
		while(txt)
			if(Parse(txt,i))
				if(before>1) .+=html_encode(copytext(txt,1,before))
				.+=ReplacementImg()
				txt=copytext(txt,after)
				continue
			else
				.+=html_encode(txt)
				break

















////////////////////////////////////////////////////////////
// Spuzzum's Cute Speech Bubble Library!                  //
//            by (you guessed it) Jeremy "Spuzzum" Gibson //
////////////////////////////////////////////////////////////

#define ICON_NAME 'bubbles.dmi'

mob
	var
		obj/s_bubble/s_bubble
	proc
		BubbleTalk(duration = 30)
			src.BubbleCustom(ICON_NAME,"talk",duration)

		BubbleHappy(duration = 10)
			src.BubbleCustom(ICON_NAME,"happy",duration)

		BubbleAngry(duration = 10)
			src.BubbleCustom(ICON_NAME,"anger",duration)

		BubbleSigh(duration = 10)
			src.BubbleCustom(ICON_NAME,"sigh",duration)

		BubbleX(duration = 10)
			src.BubbleCustom(ICON_NAME,"X",duration)

		BubbleO(duration = 10)
			src.BubbleCustom(ICON_NAME,"O",duration)

		BubbleSad(duration = 10)
			src.BubbleCustom(ICON_NAME,"sad",duration)

		BubbleFrown(duration = 10)
			src.BubbleCustom(ICON_NAME,"mad",duration)

		BubbleExclaim(duration = 10)
			src.BubbleCustom(ICON_NAME,"!",duration)

		BubbleQuery(duration = 10)
			src.BubbleCustom(ICON_NAME,"?",duration)

		BubbleLove(duration = 10)
			src.BubbleCustom(ICON_NAME,"love",duration)

		BubbleIdea(duration = 10)
			src.BubbleCustom(ICON_NAME,"idea",duration)

		BubbleSing(duration = 10)
			src.BubbleCustom(ICON_NAME,"sing",duration)

		BubbleGrin(duration = 10)
			src.BubbleCustom(ICON_NAME,"grin",duration)

		BubbleTongue(duration = 10)
			src.BubbleCustom(ICON_NAME,"tongue",duration)

		BubbleLaugh(duration = 10)
			src.BubbleCustom(ICON_NAME,"laugh",duration)

		BubbleWink(duration = 10)
			src.BubbleCustom(ICON_NAME,"wink",duration)

		BubbleCustom(icon as icon,icon_state as text,duration = 10)
			del(src.s_bubble)
			src.s_bubble = new
			spawn() src.s_bubble.Display(src,icon,icon_state,duration)

obj/s_bubble/proc/Display(mob/M,icon,icon_state,duration)
	src.layer = 6
	var/turf/T = locate(M.x,M.y+1,M.z)
	if(T)
		src.loc = T
	else
		src.loc = M.loc
	src.icon = icon
	flick("popup",src)
	sleep(2)
	src.icon_state = icon_state
	sleep(duration)
	flick("popdown",src)
	sleep(2)
	del(src)

mob/Move()
	. = ..()
	if(src.s_bubble)
		var/turf/T = locate(src.x,src.y+1,src.z)
		if(T)
			src.s_bubble.loc = T
		else
			src.s_bubble.loc = src.loc
	return .

mob
	verb/Laugh()
		set category = "Bubbles"
		src.BubbleLaugh()
	verb/grin()
		set category = "Bubbles"
		src.BubbleGrin()
	verb/smile()
		set category = "Bubbles"
		src.BubbleHappy()
	verb/stick_out_tongue()
		set category = "Bubbles"
		src.BubbleTongue()
	verb/exclaim(T as text)
		set category = "Bubbles"
		src.BubbleExclaim()
		world << "\blue \<[src.name] exclaims:> [T]"
	verb/ask(T as text)
		set category = "Bubbles"
		src.BubbleQuery()
		world << "\blue \<[src.name] asks:> [T]"
	verb/be_angry()
		set category = "Bubbles"
		src.BubbleAngry()
	verb/frown()
		set category = "Bubbles"
		src.BubbleFrown()
	verb/be_in_love()
		set category = "Bubbles"
		src.BubbleLove()
	verb/wink()
		set category = "Bubbles"
		src.BubbleWink()
	verb/sing(T as text)
		set category = "Bubbles"
		src.BubbleSing()
		world << "\blue \<[src.name] sings:> [T]"